(function ($) {

  Drupal.behaviors.aliasLockPath = {
    attach: function (context) {

      var $alias = $('.form-item-alias input', context),
        $aliasWrap = $alias.parent('.form-item'),

        // The lock/unlock alias toggle.
        $lock = $('.form-item-alias-lock input', context),
        $lockWrap = $lock.parents('.form-item'),

        // The already saved, locked alias, if any.
        savedLockedAlias = $lock.data('alias-lock'),

        // The form wrapping the lock check.
        $form = $lock.parents('form'),

        // The node delete button.
        $deleteButton = $form.find('input[value=Delete]'),

        // The lock-was-removed message.
        $disabled = $('.js-alias-lock__disabled', context);

      /**
       * Reflect the state of the lock in the UI.
       */
      function updateUI() {
        var alias = $alias.val().trim(),
          state = $lock.is(':checked');

        // Remove the lock toggle when no alias is present.
        if (!alias) {
          $lockWrap.addClass('element-hidden');
        }
        else {
          $lockWrap.removeClass('element-hidden');
        }

        var $group = $deleteButton.add($disabled);

        // Hide the alias textarea, unless there is an error.
        if (!$alias.hasClass('error')) {
          $group = $group.add($aliasWrap);
        }

        // If the lock is on...
        if (state) {
          $group.addClass('element-hidden');
        }
        else {
          $group.removeClass('element-hidden');
        }

        // If the alias has changed for initial
        if (savedLockedAlias) {
          if (alias !== savedLockedAlias) {
            $disabled.removeClass('element-hidden');
            $lockWrap.addClass('element-hidden');
          }
          else {
            $disabled.addClass('element-hidden');
            $lockWrap.removeClass('element-hidden');
          }
        }
      }

      updateUI();
      $lock.once().click(function () {
        updateUI();
      });
      $alias.once().keyup(function () {
        updateUI();
      });

    }
  };

})(jQuery);
